/*
 * Copyright (c) 2007-2008 University of Washington
 * 
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _COMMON_H_
#define _COMMON_H_

#if !defined( __APPLE__ )
#define _GNU_SOURCE // for getline
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <limits.h>

/* Types */
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned short ushort;

/* Macros */
#ifndef TRUE
    #define TRUE 1
#endif

#ifndef FALSE
    #define FALSE 0
#endif

#define SUCCESS TRUE
#define FAILURE FALSE


// TODO: this assumes TRUE < FALSE. Should probably fix? 
#define CONTINUE (TRUE + 1)

#define IN
#define OUT
#define INOUT

#define HOSTNAME_ALLOWED_CHARS "abcdefghijklmnopqrtsuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.-"
//"normal" filename chars
#define FILENAME_ALLOWED_CHARS "abcdefghijklmnopqrtsuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.-_~/ \\:"

#if defined( __CYGWIN__ )
#define NEWLINE_CHAR "\r\n"
#else
#define NEWLINE_CHAR "\n"
#endif

#endif // _COMMON_H_
