/*
 * Copyright (c) 2007-2008 University of Washington
 * 
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _TRACEROUTE_H_
#define _TRACEROUTE_H_

#include <netinet/in.h>
#include "common.h"

#define TR_HOP_LIMIT_STR "20"
#define TR_HOP_LIMIT 20
#define TR_NPROBES 1

typedef enum
{
    NORMAL,
    COMPACT,
    FRIENDLY
} trpstyle_t;

typedef struct _hop_t
{
    struct in_addr ip;
    float rtt;
} hop_t;

typedef struct _probe_t
{
    struct in_addr target;
    hop_t hops[TR_HOP_LIMIT];
} probe_t;

#define TR_DATA_UPPERBOUND \
   ( TR_NPROBES * ( sizeof( probe_t ) ) )

int get_traceroutes( uchar** data OUT, int* len OUT );

int print_traceroutes( FILE* file, uchar* data IN, int len IN, trpstyle_t style IN );

#endif // _TRACEROUTE_H_

