/*
 * Copyright (c) 2007-2008 University of Washington
 * 
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _OPENDHT_H_
#define _OPENDHT_H_

#include <netinet/in.h>
#include "common.h"
#include "gateways.h"

#define OPENDHT_KEYSIZE 20
#define OPENDHT_PORT 5852
#define OPENDHT_MAX_PUTLEN 1024

enum
{
    DHT_SUCCESS,
    DHT_TIMEOUT, 
    DHT_FAILURE
};

typedef uchar dhtkey_t[OPENDHT_KEYSIZE];

int opendht_connect( struct in_addr serverip IN, int port IN );
int opendht_disconnect( void );
int opendht_isconnected( void );

int opendht_put( dhtkey_t key IN, uchar* value IN, int vlen IN );
int opendht_get( dhtkey_t key IN, uchar** result OUT, unsigned int* rlen OUT );

#endif // _OPENDHT_H_

