#!/bin/bash

if [ $# != 1 ]; then
    echo "usage: $0 <enablephotos, 1 or 0>"
    exit 1;
fi

ADEONAVERSION=0.2.1
PHOTOSENABLED=$1

# Make sure these are pointed correctly
SRCDIR=../..
PKGFILESDIR=packagefiles

# Adeona options
ADEONAPREFIX=/usr/local/adeona

# Package options
PACKAGEROOT=adeona-package-full
PACKAGECONTENT=$PACKAGEROOT/adeona
PACKAGERESOURCES=$PACKAGEROOT/resources

ADEONARESOURCES=$PACKAGECONTENT/resources 
ADEONALOGS=$PACKAGECONTENT/logs
ADEONASCRIPTS=$PACKAGECONTENT/scripts
ADEONAINSTALL=$PACKAGECONTENT/install

#####################################################################
(cd $SRCDIR && make clean-all)
(cd $SRCDIR && make RELEASE=1)

if [ -d $PACKAGEROOT ]; then
    rm -rf $PACKAGEROOT;
fi

mkdir $PACKAGEROOT;
mkdir $PACKAGECONTENT;
mkdir $PACKAGERESOURCES;

mkdir $ADEONARESOURCES;
mkdir $ADEONALOGS;
mkdir $ADEONASCRIPTS;
mkdir $ADEONAINSTALL; #to be wiped out after installation

# Copy files
cp $SRCDIR/adeona-client.exe $PACKAGECONTENT;
cp $SRCDIR/adeona-retrieve.exe $PACKAGECONTENT;
cp $SRCDIR/adeona-init.exe $PACKAGECONTENT;

ADEONARESFILES="gateways.adeona landmarks.adeona";
for res in $ADEONARESFILES; do
    cp $SRCDIR/resources/$res $ADEONARESOURCES/$res;
done

if [ "$PHOTOSENABLED" == "1" ]; then
    cp $SRCDIR/resources/isightcapture.exe $ADEONARESOURCES/isightcapture.exe;
    cp $SRCDIR/resources/isightcapture-license.rtf $ADEONARESOURCES/isightcapture-license.rtf;
fi

# specify full paths and specify USE_WEBCAMIMG
sed -e "s/resources\//"${ADEONAPREFIX//\//\\\/}"\/resources\//g" \
    -e "s/adeona\.log/"${ADEONAPREFIX//\//\\\/}"\/logs\/adeona\.log/g" \
    -e "s/USE_WEBCAMIMG = 0/USE_WEBCAMIMG = $PHOTOSENABLED/" $SRCDIR/resources/options.adeona > $ADEONARESOURCES/options.adeona

cp $PKGFILESDIR/adeona_term_background.jpg $ADEONARESOURCES/adeona_term_background.jpg 
cp $PKGFILESDIR/edu.washington.cs.adeona.plist.10.4 $ADEONAINSTALL/edu.washington.cs.adeona.plist.10.4
cp $PKGFILESDIR/edu.washington.cs.adeona.plist.10.5 $ADEONAINSTALL/edu.washington.cs.adeona.plist.10.5

#cp $PKGFILESDIR/terminals/adeona-init.term $ADEONAINSTALL   
cp $PKGFILESDIR/terminals/adeona-retrieve.term $PACKAGECONTENT

#cp $PKGFILESDIR/scripts/adeona-init.sh $ADEONAINSTALL
cp $PKGFILESDIR/scripts/adeona-retrieve.sh $ADEONASCRIPTS/adeona-retrieve.sh

cp $SRCDIR/Readme.txt $PACKAGECONTENT/Readme.txt

cp $PKGFILESDIR/adeona_globeonly_trans.png $PACKAGERESOURCES/adeona_globeonly_trans.png
cp $PKGFILESDIR/preflight $PACKAGERESOURCES/preflight
cp $PKGFILESDIR/postflight.full $PACKAGERESOURCES/postflight
cp $PKGFILESDIR/Welcome.txt $PACKAGERESOURCES/Welcome.txt
cp $SRCDIR/License.txt $PACKAGERESOURCES/License.txt
cp $SRCDIR/Conclusion.txt $PACKAGERESOURCES/Conclusion.txt
cp $SRCDIR/Readme.txt $PACKAGERESOURCES/Readme.txt

