!include nsDialogs.nsh
!include LogicLib.nsh
!include FileFunc.nsh

SetCompressor zlib

!insertmacro GetTime

;
;http://nsis.sourceforge.net/Another_String_Replace_(and_Slash/BackSlash_Converter)
;
Function StrRep
  Exch $R4 ; $R4 = Replacement String
  Exch
  Exch $R3 ; $R3 = String to replace (needle)
  Exch 2
  Exch $R1 ; $R1 = String to do replacement in (haystack)
  Push $R2 ; Replaced haystack
  Push $R5 ; Len (needle)
  Push $R6 ; len (haystack)
  Push $R7 ; Scratch reg
  StrCpy $R2 ""
  StrLen $R5 $R3
  StrLen $R6 $R1
loop:
  StrCpy $R7 $R1 $R5
  StrCmp $R7 $R3 found
  StrCpy $R7 $R1 1 ; - optimization can be removed if U know len needle=1
  StrCpy $R2 "$R2$R7"
  StrCpy $R1 $R1 $R6 1
  StrCmp $R1 "" done loop
found:
  StrCpy $R2 "$R2$R4"
  StrCpy $R1 $R1 $R6 $R5
  StrCmp $R1 "" done loop
done:
  StrCpy $R3 $R2
  Pop $R7
  Pop $R6
  Pop $R5
  Pop $R2
  Pop $R1
  Pop $R4
  Exch $R3
FunctionEnd

Name AdeonaRecovery
OutFile packagefiles\AdeonaRecovery.exe

Var Dialog
Var Label

Var TextFromDate
Var FromDate

Var TextUntilDate
Var UntilDate

Var TextNumLocs
Var NumLocs
Var allButton
Var someButton
Var allButton_state
Var someButton_state

Var passwordbox
Var password

Var OwnerFile
Var AdBatFile
Var AdDirectory
Var desktopDir
;Var paramp
Var paraml
Var parame
Var paramt
Var paramn
Var failure

Icon "adeona_globeonly_trans.ico"
caption "Adeona v0.2.1 Recovery Wizard"
subcaption 3 ": Attempting recovery"
InstallButtonText "Launch"

Page custom introPage
Page custom locationPage locationPageEnd
Page custom locationBPage locationBPageEnd
Page custom passwordPage passwordPageEnd
Page custom doitPage doitPageEnd
Page custom finishedPage
;Page instfiles
ShowInstDetails nevershow

Function introPage
   nsDialogs::Create /NOUNLOAD 1018
   Pop $Dialog
   

   ${If} $Dialog == error
      Abort
   ${EndIf}

   ${NSD_CreateLabel} 0 0 100% 12u "Welcome to the Adeona Recovery Wizard."
   Pop $Label

   ${NSD_CreateLabel} 0 23u 100% 12u "First, click next to open your owner recovery file"
   Pop $Label

   ${NSD_CreateLabel} 0 36u 100% 12u "For example, C:\Program Files\Adeona\adeona-retrievecredentials.ost"
   Pop $Label

   nsDialogs::Show
   
FunctionEnd


Function locationPage
   nsDialogs::Create /NOUNLOAD 1018
   Pop $Dialog

   ${If} $Dialog == error
      Abort
   ${EndIf}

   nsDialogs::SelectFileDialog /NOUNLOAD open "$EXEDIR\adeona-retrievecredentials.ost" "*.ost"
   Pop $OwnerFile
   
   ${NSD_CreateLabel} 0 0 100% 24u "You specified $OwnerFile"
   Pop $Label

   ${NSD_CreateLabel} 0 23u 100% 12u "When do you want to search?"
   Pop $Label

   ${NSD_CreateLabel} 0 49u 100% 12u "Use 24-hour time for hh:mm (e.g. 14:45 specifies 2:45 PM)"
   Pop $Label

   ${NSD_CreateLabel} 0 36u 100% 12u "Leave blank if you want defaults (from two days ago until now)"
   Pop $Label


   
   ${NSD_CreateLabel} 0 75u 35% 12u "From (MM/DD/YYYY,hh:mm)"
   Pop $Label

   ${NSD_CreateText} 35% 75u 65% 12u ""
   Pop $TextFromDate

   ${NSD_CreateLabel} 0 88u 35% 12u "Until (MM/DD/YYYY,hh:mm)"
   Pop $Label

   ${NSD_CreateText} 35% 88u 65% 12u ""
   Pop $TextUntilDate


   nsDialogs::Show
FunctionEnd

Function locationPageEnd
   ${NSD_GetText} $TextFromDate $FromDate
   ${NSD_GetText} $TextUntilDate $UntilDate
FunctionEnd


Function locationBPage
   nsDialogs::Create /NOUNLOAD 1018
   Pop $Dialog

   ${If} $Dialog == error
      Abort
   ${EndIf}

   ${NSD_CreateLabel} 0 0 100% 12u "How many locations should we attempt to find?"
   Pop $Label
   
   
   ${NSD_CreateRadioButton} 10% 13u 20% 12u "Find first "
   Pop $someButton
   nsDialogs::OnChange /NOUNLOAD $someButton onClickRadios

   ${NSD_CreateText} 30% 13u 20% 12u "1"
   Pop $TextNumLocs
   
   ${NSD_CreateRadioButton} 10% 26u 20% 12u "Find all"
   Pop $allButton
   nsDialogs::OnChange /NOUNLOAD $allButton onClickRadios

   ${NSD_SetState} $someButton ${BST_CHECKED}
   ${NSD_SetState} $allButton ${BST_UNCHECKED}

   nsDialogs::Show
FunctionEnd

Function locationBPageEnd
   ${NSD_GetState} $someButton $someButton_state
   ${NSD_GetState} $someButton $allButton_state
   ${If} $someButton_state == ${BST_CHECKED}
         ${NSD_GetText} $TextNumLocs $NumLocs
   ${EndIf}
FunctionEnd



Function onClickRadios
   Pop $0  ; this is the HWND
   ${If} $0 == $allButton
         ${NSD_SetState} $someButton ${BST_UNCHECKED}
   ${Else}
         ${NSD_SetState} $allButton ${BST_UNCHECKED}
   ${EndIf}
FunctionEnd

Function passwordPage
   nsDialogs::Create /NOUNLOAD 1018
   Pop $Dialog

   ${If} $Dialog == error
      Abort
   ${EndIf}

   ${NSD_CreateLabel} 0 0 100% 12u "Please enter your Adeona password."
   Pop $Label

   ${NSD_CreatePassword} 10% 13u 50% 12u ""
   Pop $passwordbox

   ${NSD_SetText} $passwordbox ""

   ${NSD_SetFocus} $passwordbox
   
   nsDialogs::Show
FunctionEnd

Function passwordPageEnd
   ${NSD_GetText} $passwordbox $password
FunctionEnd


Function doitPage
   nsDialogs::Create /NOUNLOAD 1018
   Pop $Dialog

   ${NSD_CreateLabel} 0 0 100% 12u "Clicking next will launch the recovery program."
   Pop $Label

   ;${NSD_CreateLabel} 0 26 100% 12u "This will prompt you for your owner password."
   ;Pop $Label

   ${NSD_CreateLabel} 0 52 100% 12u "Note that retrieving updates may take some time."
   Pop $Label

   nsDialogs::Show
FunctionEnd

Function doitPageEnd
  ${GetTime} "" "L" $0 $1 $2 $3 $4 $5 $6
  StrCpy $desktopDir "$DESKTOP\adeonaretrieval-$1-$0-$2-$4$5"
  CreateDirectory "$desktopDir"

;  StrCpy $paraml "$desktopDir\$\""
  StrCpy $paraml "$desktopDir\\"

  ;${If} $password == ""
  ;      StrCpy $paramp ""
  ;${Else}
  ;      StrCpy $paramp "-p $password"
  ;${EndIf}

  StrCpy $paramt ""
  StrCpy $parame ""
  StrCpy $paramn ""

  ${If} $FromDate != ""
        StrCpy $paramt "-t $FromDate"
  ${Else}
        StrCpy $paramt "-t NOFROMDATE"
  ${EndIf}

  ${If} $UntilDate != ""
        StrCpy $parame "-e $UntilDate"
  ${Else}
        StrCpy $parame "-e NOUNTILDATE"
  ${EndIf}

  ${If} $someButton_state == ${BST_CHECKED}
        StrCpy $paramn "-n $NumLocs"
  ${EndIf}


  StrCpy $AdDirectory "$EXEDIR"
  StrCpy $AdBatFile "$EXEDIR\adeona-retrieve.bat"

  IfFileExists "$EXEDIR\adeona-retrieve.bat" 0 +2
  IfFileExists "$EXEDIR\adeona-retrieve.exe" DOIT 0
    MessageBox MB_OK "Can't find retrieval executables (adeona-retrieve.bat and adeona-retrieve.exe). $\n$\n\
            Please specify the directory where these are installed.\
            (e.g., C:\Program Files\Adeona)" IDOK true
    true:
       nsDialogs::SelectFolderDialog /NOUNLOAD open ""
       Pop $AdDirectory
       StrCpy $AdBatFile "$AdDirectory\adeona-retrieve.bat"
       IfFileExists $AdBatFile 0 FAILURE
       SetOutPath $AdDirectory ; sets working directory for the batch file
       Goto DOIT

  DOIT:
;    Push $OwnerFile
;    Push "\"
;    Push "\\"
;    Call StrRep
;    Pop $OwnerFile
;
;    Push $paraml
;    Push "\"
;    Push "\\"
;    Call StrRep
;    Pop $paraml
;
;    Push $AdDirectory
;    Push "\"
;    Push "\\"
;    Call StrRep
;    Pop $AdDirectory

    ; This is the work around for Vista.
    FileOpen $0 "$paraml\adeona_retrieve_results.txt" w
    FileClose $0

    ExecWait '"$AdBatFile" $\"$password$\" $\"$OwnerFile$\" $\"$paraml$\" $\"$AdDirectory\resources\\$\" $\"$paramt$\" $\"$parame$\" $\"$paramn$\"' $0
        
    ${If} $0 == 1
          StrCpy $failure "true"
          ; failure, try again
          MessageBox MB_OK "Retrieval failed. $\n$\n\
            Please check your password and try again." IDOK FAILURE
    ${EndIf}
    StrCpy $failure "false"
    Goto SUCCESS

  FAILURE:
    DetailPrint "Operation failed: couldn't find retrieval executables."

  SUCCESS:

FunctionEnd

Function finishedPage

   ${If} $failure == "true"
         Abort
   ${EndIf}
   
   nsDialogs::Create /NOUNLOAD 1018
   Pop $Dialog


   ${NSD_CreateLabel} 0 0 100% 100% "Results have been stored in $\n$\n$\n   $desktopdir $\n$\n$\n\
                          located on your desktop. Please dispose of the information properly when done."
   Pop $Label

   nsDialogs::Show
FunctionEnd


Section

SectionEnd