/*
 * Copyright (c) 2007-2008 University of Washington
 * 
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _REMSTORE_H_
#define _REMSTORE_H_

#include "common.h"
#include "opendht.h"

#define RS_CHUNKHDR_MAGIC "ADEONA02" // there is some weird alignment stuff that two bytes is added if i make this ADEONA

#define RS_CHUNKHDR_MAGIC_LEN 8

#define RS_MAX_PUTLEN ( OPENDHT_MAX_PUTLEN - sizeof( chunkhdr_t ) )

typedef struct _chunkhdr_t
{
    char ident[RS_CHUNKHDR_MAGIC_LEN];
    uint numchunks; //total number of chunks in the data this belongs to
    uint currchunk; //this is the i-th chunk
    uint chunklen;  //length of this chunk in bytes 
} chunkhdr_t;

/* iterator over a get result */
typedef struct _getiter_t
{
    uchar* data;
    uint curroff;
    uint len;
} getiter_t;

int remstore_connect( void );
int remstore_isconnected( void );
int remstore_put( dhtkey_t key IN, uchar* data IN, int dlen IN );
int remstore_getiter_init( dhtkey_t key IN, getiter_t* iter OUT );
int remstore_getiter_next_alloc( getiter_t* iter IN, uchar** data OUT, int* dlen OUT );
int remstore_getiter_next( getiter_t* iter IN, uchar* data OUT, int dlen IN );
int remstore_getiter_done( getiter_t* iter IN );
int remstore_disconnect( void );

#endif // _REMSTORE_H_
